package ch.lanter.vajanoid;

/**
 * Ball Events are the events launched by the model to inform its observers
 * about changes.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class BallEvent {

	/**
	 * Type of an Event
	 */
	public enum TYPE {
		BALL_PADDED, BLOCK_DEATH, LIFE_LOST, LIFE_GAINED,
		RESTERT, NEXT_LEVEL, ITEM_RELEASED, CHEATED,
		SCORED, CURSOR;
	}
	
	private int x,y;
	private TYPE type;
	
	/**
	 * Global events without a specific location
	 */
	public BallEvent(TYPE type) {
		this(-1,-1,type);
	}
	
	/**
	 * Local events with specific coordinates
	 */
	public BallEvent(int x, int y, TYPE type) {
		this.x = x;
		this.y = y;
		this.type = type;
	}
	
	public TYPE getType() {
		return type;
	}
	
	public int getX() {
		return x;
	}
	
	public int getY() {
		return y;
	}
}
