package ch.lanter.vajanoid;

/**
 * Commands for the Controller which knows how to handle them
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class Command {

	/**
	 * Command Strings. Must be lower case!
	 */
	public final static String START = "start"; 
	public final static String PAUSE = "pause"; 
	public final static String UNLOCK = "unlock";
	public final static String NEXT = "_next";
	public final static String LIVES = "_lives";
	public final static String ZERO = "_zero";
	public final static String ITEMS = "_items";
	public final static String SHOT = "_shot";
	public final static String GOLD = "_gold";
	public final static String OVER = "_over";
	public final static String WINNER = "_winner";
	public final static String LANTERSOFT = "lantersoft";
	public final static String LEVEL = "level";
	public final static String INFO = "info";
	public final static String HELP = "help";
	public final static String FIRE = "fire";
	
	public static boolean isCheat(String cmd) {
		return cmd.equals(NEXT) ||
				cmd.equals(LIVES) ||
				cmd.equals(ZERO) ||
				cmd.equals(ITEMS) ||
				cmd.equals(SHOT) ||
				cmd.equals(GOLD) ||
				cmd.equals(OVER) ||
				cmd.equals(WINNER) ||
				cmd.equals(LANTERSOFT);
	}
}
