package ch.lanter.vajanoid;

/**
 * An Eventable object is able to launch an Event through the model, which
 * updates its observers. Furthermore it is able to call the model and increase
 * the score.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public interface Eventable {

	// make the model notify its observers with this event as argument
	public void launchEvent(BallEvent event);
	
	// make the model increase the score
	public void addScore(int add);
}
