package ch.lanter.vajanoid;

import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;

import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

import ch.lanter.vajanoid.gui.PnlContent;

/**
 * Main class of Vajanoid
 * 
 * All Rights reserved
 * @author Martin Lanter, Lantersoft 2010
 */
public class Vajanoid extends JApplet {

	private static final long serialVersionUID = 201001130139L;
	
	/**
	 * Launch as application
	 */
	public static void main(String[] args) {
		System.out.println("Vajanoid Start");
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				final PnlContent pnlContent = new PnlContent();
				final Controller controller = new Controller(pnlContent);
				controller.start();
				
				final JFrame frame = new JFrame("Vajanoid");
				frame.addWindowFocusListener(new WindowFocusListener() {
					public void windowGainedFocus(WindowEvent e) {}
					public void windowLostFocus(WindowEvent e) {
						controller.setPause(true);
					}
				});

				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.add(pnlContent);
				frame.pack(); // Actually (400,356) but the stupid setresizable changes the size unaffiliatedly ?!? (earlier:setSize(390+pnlButtons.getPreferredSize().width,347)
				frame.setLocationByPlatform(true);
				frame.setVisible(true);
			}
		});
	}
	
	/**
	 * Launch as Applet
	 */
	public void init() {
		System.out.println("Vajanoid Start");
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				PnlContent pnlContent = new PnlContent();
				Controller controller = new Controller(pnlContent);
				controller.start();
				
				getContentPane().add(pnlContent);
				setSize(478,356);
			}
		});
	}
}
