package ch.lanter.vajanoid.block;

import ch.lanter.vajanoid.Eventable;

/**
 * A Behavior defines what happens, when a ball or a shot hits the block
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public interface Behavior {
	
	// called if a ball has stroked a block
	public void blockStroked(int x, int y, Eventable eventable);

	// called if a shot has hit a block
	public void blockShot(int x, int y, Eventable eventable);
	
	// called if a ball or a shot has destroyed a block
	public void blockDestroyed(int x, int y, int hp, Eventable eventable);
	
}
