package ch.lanter.vajanoid.block;

import ch.lanter.vajanoid.BallEvent;
import ch.lanter.vajanoid.Eventable;
import ch.lanter.vajanoid.BallEvent.TYPE;

/**
 * DefaultBehavior doesn't do anything unless the block has been destroyed. Then
 * it adds some points for destroying the block and launchs a BLOCK_DEATH Event.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class DefaultBehavior implements Behavior {
	
	public void blockStroked(int x, int y, Eventable eventable) { }

	public void blockShot(int x, int y, Eventable eventable) { }
	
	public void blockDestroyed(int x, int y, int hp, Eventable eventable) {
		eventable.addScore(10*hp);
		eventable.launchEvent(new BallEvent(x,y,TYPE.BLOCK_DEATH));
	}
	
}
