package ch.lanter.vajanoid.block;

import ch.lanter.vajanoid.Eventable;

/**
 * The EmptyBehavior does nothing except add some points if the block has been
 * destroyed.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class EmptyBehavior implements Behavior {

	@Override
	public void blockDestroyed(int x, int y, int hp, Eventable eventable) {
		eventable.addScore(10*hp);
	}

	@Override
	public void blockShot(int x, int y, Eventable eventable) {
		// do nothing
	}

	@Override
	public void blockStroked(int x, int y, Eventable eventable) {
		// do nothing
	}

}
