package ch.lanter.vajanoid.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JPanel;
import javax.swing.JTextField;

import ch.lanter.vajanoid.BallEvent;
import ch.lanter.vajanoid.Command;
import ch.lanter.vajanoid.Model;
import ch.lanter.vajanoid.BallEvent.TYPE;

/**
 * The text component in the south east of the panel, where all level codes and
 * commands are entered.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class CmpCheat extends JPanel implements Observer {

	private static final long serialVersionUID = 201001130145L;

	private Model model;

	public CmpCheat(Model model, final ActionListener al) {
		super(new FlowLayout());
		this.model = model;
		model.addObserver(this);
		setOpaque(false);

		final JTextField txfCheat = new JTextField(6);
		txfCheat.addActionListener(al);
		txfCheat.setOpaque(false);
		txfCheat.setBorder(null);
		txfCheat.setSelectionColor(new Color(0,0,0,0));
		txfCheat.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent event) {
				if (event.getKeyCode()==KeyEvent.VK_CONTROL) {
					al.actionPerformed(new ActionEvent(txfCheat,KeyEvent.VK_Y,Command.FIRE));
				} else if (event.getKeyCode()==KeyEvent.VK_F6) {
					al.actionPerformed(new ActionEvent(txfCheat,KeyEvent.VK_F6,Command.NEXT));
				} else if (event.getKeyCode()==KeyEvent.VK_F3) {
					al.actionPerformed(new ActionEvent(txfCheat,KeyEvent.VK_F3,Command.PAUSE));
				} else if (event.getKeyCode()==KeyEvent.VK_F2) {
					al.actionPerformed(new ActionEvent(txfCheat,KeyEvent.VK_F2,Command.START));
				}
			}
		});
		txfCheat.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				txfCheat.setSelectionStart(0);
				txfCheat.setSelectionEnd(txfCheat.getText().length());
			}
		});
		txfCheat.setToolTipText("Enter level codes");
		setMaximumSize(new Dimension(72,txfCheat.getPreferredSize().height+10));
		add(txfCheat);
		setAlignmentY(BOTTOM_ALIGNMENT);
	}

	public void paintComponent(Graphics g) {
		int w = getWidth();
		int h = getHeight();
		if (model.hasCheated()) g.setColor(Color.RED);
		else g.setColor(new Color(200,200,255));
		g.fillRoundRect(3, 1, w-5, h-3, 5, 5);
		g.setColor(new Color(100,100,255));
		g.drawRoundRect(3, 1, w-4, h-2, 5, 5);
		g.setColor(new Color(255,255,255));
		g.drawRoundRect(2, 0, w-4, h-2, 5, 5);
	}

	@Override
	public void update(Observable o, Object arg) {
		BallEvent event = (BallEvent) arg;
		if (event.getType()==TYPE.CHEATED) {
			repaint();
		} else if (event.getType()==TYPE.RESTERT) {
			repaint();
		}
	}

}
