package ch.lanter.vajanoid.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.util.Observable;
import java.util.Observer;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JLabel;

import ch.lanter.vajanoid.BallEvent;
import ch.lanter.vajanoid.Model;
import ch.lanter.vajanoid.BallEvent.TYPE;

/**
 * Displays the number and name of the current level.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class CmpLevel extends JComponent implements Observer {

	private static final long serialVersionUID = 201001130146L;

	private Model model;

	private JLabel lblNummer;
	private JLabel lblName;

	public CmpLevel(Model model) {
		this.model = model;
		model.addObserver(this);

		setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		setOpaque(false);

		lblNummer = new HighlightLabel("Level "+model.getLevelNumber()+":",1,Color.BLACK,new Color(255,255,255,64));
		lblName = new HighlightLabel("",1,Color.BLACK,new Color(255,255,255,64));
		lblNummer.setAlignmentX(CENTER_ALIGNMENT);
		lblName.setAlignmentX(CENTER_ALIGNMENT);
		add(lblNummer);
		add(lblName);
	}

	@Override
	public Dimension getMaximumSize() {
		return getPreferredSize();
	}

	public void update(Observable o, Object arg) {
		BallEvent event = (BallEvent) arg;
		if (event.getType()==TYPE.NEXT_LEVEL) {
			int number = model.getLevelNumber();
			lblNummer.setText("Level "+number+":");
			lblName.setText(model.getLevel().getName());
		}
	}
}
