package ch.lanter.vajanoid.gui;

import java.awt.Color;
import java.util.Observable;
import java.util.Observer;

import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.border.EmptyBorder;

import ch.lanter.vajanoid.BallEvent;
import ch.lanter.vajanoid.Model;
import ch.lanter.vajanoid.BallEvent.TYPE;

/**
 * Displays the Score.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class CmpScore extends JComponent implements Observer {

	private static final long serialVersionUID = 200911062326L;

	private Model model;
	private HighlightLabel lbl;
	
	public CmpScore(Model model) {
		this.model = model;
		model.addObserver(this);
		setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		setBorder(new EmptyBorder(4,0,0,0));
		lbl = new HighlightLabel("Score: 0",1,Color.BLACK,new Color(255,255,255,64));
		lbl.setAlignmentX(CENTER_ALIGNMENT);
		add(lbl);
	}
	
	@Override
	public void update(Observable arg0, Object arg) {
		BallEvent event = (BallEvent) arg;
		if (event.getType()==TYPE.SCORED || event.getType()==TYPE.RESTERT) {
			lbl.setText("Score: "+model.getScore());
		}
	}
}
