package ch.lanter.vajanoid.gui;

import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;

import javax.swing.JPanel;

/**
 * This is the panel that lies right into the JFrame or JApplet. It only paints
 * a background and contains the view of the game area.
 * 
 * @author Martin Lanter, LanterSoft 2010
 */
public class PnlContent extends JPanel {

	private static final long serialVersionUID = 201001130150L;

	@Override
	public void paintComponent(Graphics g) {
		Graphics2D g2 = (Graphics2D) g.create();
		GradientPaint gradint = new GradientPaint(new Point(0,0),new Color(170,180,255),new Point(0,getHeight()/2),new Color(150,150,255));
		g2.setPaint(gradint);
		Rectangle clip = g.getClipBounds();
		g2.fillRect(clip.x, clip.y, clip.width, clip.height);
		g2.dispose();
	}

}
