package ch.lanter.vajanoid.level;

import java.util.Observer;

import ch.lanter.vajanoid.block.Block;

/**
 * A Level instantiates the all the blocks of the level with the according paths
 * and behavoiurs. It extends Observer for that it can be added as observer to
 * the model to catch BallEvents
 * 
 * @author Martin Lanter, Lantersoft 2010
 */
public interface Level extends Observer {

	// get all the blocks to be painted
	public Block[] getBlocks();
	
	// true if all the level is finished. Usually, if all living blocks are destroyed
	public boolean isWon();

	// return the name of the level which is also the level code
	public String getName();
	
	// called, when the level starts
	public void start();

	// called, when the game is paused
	public void pause();

	// called, when the game is resumed
	public void resume();
	
	// called, when the level is changed (e.g. it is won or game over)
	public void stop();
	
	// called from the controller at every time step with the passed time as parameter
	public void step(long dt);
	
}
