package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level01 extends AbstractLevel {

	// the blocks to be painted
	private Block[] blocks;
	
	public Level01() {
		blocks = new Block[72];
		for (int i=0;i<12;i++) { // topmost line of black blocks which need to be hit 3 times before disappearing
			blocks[i] = new RectBlock(i*32,40,BlockImage.BLACK,3);
		}
		for (int i=0;i<12;i++) { // second line of blue blocks
			blocks[i+12] = new RectBlock(i*32,60,BlockImage.BLUE,1);
		}
		for (int i=0;i<12;i++) {
			blocks[i+24] = new RectBlock(i*32,80,BlockImage.GREEN,1);
		}
		for (int i=0;i<12;i++) {
			blocks[i+36] = new RectBlock(i*32,100,BlockImage.YELLOW,1);
		}
		for (int i=0;i<12;i++) {
			blocks[i+48] = new RectBlock(i*32,120,BlockImage.ORANGE,1);
		}
		for (int i=0;i<12;i++) { // bottom line with red blocks
			blocks[i+60] = new RectBlock(i*32,140,BlockImage.RED,1);
		}
	}
	
	@Override
	public String getName() {
		return "Welcome";
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}
}
