package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.VerticalPath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level04 extends AbstractLevel {

	private Block[] blocks;
	private Path path;
	
	public Level04() {
		int i = 0;
		path = new VerticalPath(120);
		blocks = new Block[40];
		
		blocks[i++] = BlockFactory.createRockBlock(0,200);
		blocks[i++] = BlockFactory.createRockBlock(32,200);
		blocks[i++] = BlockFactory.createRockBlock(64,200);
		blocks[i++] = BlockFactory.createRockBlock(96,200);
		blocks[i++] = BlockFactory.createRockBlock(128,200);

		blocks[i++] = createArrowBlock(0,0,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(32,20,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(64,40,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(96,20,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(128,0,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(0,20,BlockImage.RED);
		blocks[i++] = createArrowBlock(32,40,BlockImage.RED);
		blocks[i++] = createArrowBlock(64,60,BlockImage.RED);
		blocks[i++] = createArrowBlock(96,40,BlockImage.RED);
		blocks[i++] = createArrowBlock(128,20,BlockImage.RED);
		
		blocks[i++] = BlockFactory.createRockBlock(224,200);
		blocks[i++] = BlockFactory.createRockBlock(256,200);
		blocks[i++] = BlockFactory.createRockBlock(288,200);
		blocks[i++] = BlockFactory.createRockBlock(320,200);
		blocks[i++] = BlockFactory.createRockBlock(352,200);
		
		blocks[i++] = createArrowBlock(224,0,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(256,20,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(288,40,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(320,20,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(352,0,BlockImage.YELLOW);
		blocks[i++] = createArrowBlock(224,20,BlockImage.RED);
		blocks[i++] = createArrowBlock(256,40,BlockImage.RED);
		blocks[i++] = createArrowBlock(288,60,BlockImage.RED);
		blocks[i++] = createArrowBlock(320,40,BlockImage.RED);
		blocks[i++] = createArrowBlock(352,20,BlockImage.RED);
		
		blocks[i++] = new RectBlock(0,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(32,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(64,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(96,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(128,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(224,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(256,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(288,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(320,220,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(352,220,BlockImage.ORANGE);
	}
	
	private Block createArrowBlock(int x, int y, BlockImage image) {
		Block ret = new RectBlock(x, y, image);
		ret.setYMax(200);
		path.addBlock(ret);
		return ret;
	}

	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
	@Override
	public Path[] getPaths() {
		return new Path[] {path};
	}

	@Override
	public String getName() {
		return "Clueless";
	}

}
