package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.PolarPath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level06 extends AbstractLevel {

	private Block[] blocks;
	private PolarPath path;
	
	public Level06() {
		int i = 0;
		blocks = new Block[64];
		path = new PolarPath(192f,140f,-2f);
		
		BlockImage image = BlockImage.GREEN;
		
		blocks[i++] = new RectBlock(176,130,image);
		
		for (int j=1;j<64;j++) {
			RectBlock b1 = new RectBlock(0,0,image);
			path.addBlock(b1,j*2f,j*(float)Math.PI/12);
			blocks[i++] = b1;
		}
	}

	@Override
	public void start() {
		path.arrange();
		super.start();
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
	@Override
	public Path[] getPaths() {
		return new Path[] {path};
	}

	@Override
	public String getName() {
		return "Death Spiral";
	}
}
