package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.HorizontalPath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level08 extends AbstractLevel {

	private Block[] blocks;
	
	private Path path1;
	private Path path2;
	
	public Level08() {
		this.path1 = new HorizontalPath(100);
		this.path2 = new HorizontalPath(-100);
		this.blocks = new Block[72];
		for (int i=0;i<12;i++) {
			path1.addBlock(
					blocks[i] = new RectBlock(i*32,40,BlockImage.BLACK,3));
		}
		for (int i=0;i<12;i++) {
			path2.addBlock(
					blocks[i+12] = new RectBlock(i*32,60,BlockImage.BLUE,1));
		}
		for (int i=0;i<12;i++) {
			path1.addBlock(
					blocks[i+24] = new RectBlock(i*32,80,BlockImage.GREEN,1));
		}
		for (int i=0;i<12;i++) {
			path2.addBlock(
					blocks[i+36] = new RectBlock(i*32,100,BlockImage.YELLOW,1));
		}
		for (int i=0;i<12;i++) {
			path1.addBlock(
					blocks[i+48] = new RectBlock(i*32,120,BlockImage.ORANGE,1));
		}
		for (int i=0;i<12;i++) {
			path2.addBlock(
					blocks[i+60] = new RectBlock(i*32,140,BlockImage.RED,1));
		}
	}
	
	@Override
	public Path[] getPaths() {
		return new Path[] {path1,path2};
	}
	
	@Override
	public String getName() {
		return "Conveyer";
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
}