package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.HorizontalPath;
import ch.lanter.vajanoid.path.VerticalSwayPath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level10 extends AbstractLevel {

	private Block[] blocks;
	private Path path1, path2, path3;
	
	public Level10() {
		int i = 0;
		path1 = new HorizontalPath(120);
		path2 = new VerticalSwayPath(40,120);
		path3 = new VerticalSwayPath(40,120,40);
		blocks = new Block[32];
		
		blocks[i++] = createSwayRockBlock(0,200,path2);
		blocks[i++] = createSwayRockBlock(64,240,path3);
		blocks[i++] = createSwayRockBlock(128,200,path2);
		blocks[i++] = createSwayRockBlock(192,240,path3);
		blocks[i++] = createSwayRockBlock(256,200,path2);
		blocks[i++] = createSwayRockBlock(320,240,path3);

		blocks[i++] = new RectBlock(48, 60,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(48, 80,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(48,100,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(48,120,BlockImage.PURPLE);
		
		blocks[i++] = new RectBlock(80, 40,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(80, 60,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(80,120,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(80,140,BlockImage.PURPLE);
		
		blocks[i++] = new RectBlock(112, 40,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(112, 140,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(144, 60,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(144,120,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(176, 80,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(176,100,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(208, 60,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(208,120,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(240, 40,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(240,140,BlockImage.PURPLE);
		
		blocks[i++] = new RectBlock(272, 40,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(272, 60,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(272,120,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(272,140,BlockImage.PURPLE);
		
		blocks[i++] = new RectBlock(304, 60,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(304, 80,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(304,100,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(304,120,BlockImage.PURPLE);
	}
	
	private Block createSwayRockBlock(int x, int y, Path path) {
		Block ret = BlockFactory.createRockBlock(x, y);
		path1.addBlock(ret);
		path.addBlock(ret);
		return ret;
	}

	@Override
	public Block[] getBlocks() {
		return blocks;
	}

	@Override
	public Path[] getPaths() {
		return new Path[] {path1,path2,path3};
	}
	
	@Override
	public String getName() {
		return "Infinity";
	}
	
}
