package ch.lanter.vajanoid.level;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

import javax.swing.Timer;

import ch.lanter.vajanoid.ItemReleasedEvent;
import ch.lanter.vajanoid.ItemType;
import ch.lanter.vajanoid.Model;
import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level11 extends AbstractLevel {

	// blocks to be painted
	private Block[] blocks;
	
	private Model model;
	private Timer timer;
	
	public Level11(Model model) {
		this.model = model;
		int i = 0;
		blocks = new Block[38];
		blocks[i++] = new RectBlock(64,40,BlockImage.BLACK,3); // E
		blocks[i++] = new RectBlock(64,60,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(64,80,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(64,100,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(64,120,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(96,40,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(96,80,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(96,120,BlockImage.BLACK,3);

		blocks[i++] = new RectBlock(128,40,BlockImage.BLACK,3); // T
		blocks[i++] = new RectBlock(160,40,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(192,40,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(160,60,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(160,80,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(160,100,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(160,120,BlockImage.BLACK,3);

		blocks[i++] = new RectBlock(224,40,BlockImage.BLACK,3); // H
		blocks[i++] = new RectBlock(224,60,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(224,80,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(224,100,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(224,120,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(256,80,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(288,40,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(288,60,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(288,80,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(288,100,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(288,120,BlockImage.BLACK,3); // 26 block
		
		for (int j=0;j<12;j++)
			blocks[i++] = new RectBlock(j*32,200,BlockImage.WHITE,2);
	}
	
	@Override
	public void start() {
		super.start();
		timer = new Timer(500,new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				launchItems();
			}
		});
		timer.setInitialDelay(2000);
		timer.start();
	}
	
	@Override
	public void stop() {
		if (timer!=null)
			timer.stop();
	}
	
	private void launchItems() {
		int x = new Random().nextInt(model.getWidth());
		model.notifyObservers(new ItemReleasedEvent(x, 0, ItemType.BLACK));
	}
	
	@Override
	public void pause() {
		if (timer!=null)
			timer.stop();
	}
	
	@Override
	public void resume() {
		if (timer!=null) {
			timer.setInitialDelay(0);
			timer.start();
		}
	}
	
	@Override
	public String getName() {
		return "ETH";
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}

}
