package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.HorizontalPath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level12 extends AbstractLevel {

	private Block[] blocks;
	private Path[] paths;
	
	public Level12() {
		int i = 0;
		blocks = new Block[30];
		paths = new Path[2];

		paths[0] = new HorizontalPath(120f);
		paths[1] = new HorizontalPath(-120f);

		blocks[i++] = createRockWithPath(  0,100);
		blocks[i++] = createRockWithPath( 64,100);
		blocks[i++] = createRockWithPath(128,100);
		blocks[i++] = createRockWithPath(192,100);
		blocks[i++] = createRockWithPath(256,100);
		blocks[i++] = createRockWithPath(320,100);

		blocks[i++] = createRockWithPath(  0,140);
		blocks[i++] = createRockWithPath( 64,140);
		blocks[i++] = createRockWithPath(128,140);
		blocks[i++] = createRockWithPath(192,140);
		blocks[i++] = createRockWithPath(256,140);
		blocks[i++] = createRockWithPath(320,140);

		blocks[i++] = createRockWithPath(  0,180);
		blocks[i++] = createRockWithPath( 64,180);
		blocks[i++] = createRockWithPath(128,180);
		blocks[i++] = createRockWithPath(192,180);
		blocks[i++] = createRockWithPath(256,180);
		blocks[i++] = createRockWithPath(320,180);

		blocks[i++] = createBlockWithPath(  0,120);
		blocks[i++] = createBlockWithPath( 64,120);
		blocks[i++] = createBlockWithPath(128,120);
		blocks[i++] = createBlockWithPath(192,120);
		blocks[i++] = createBlockWithPath(256,120);
		blocks[i++] = createBlockWithPath(320,120);

		blocks[i++] = createBlockWithPath(  0,160);
		blocks[i++] = createBlockWithPath( 64,160);
		blocks[i++] = createBlockWithPath(128,160);
		blocks[i++] = createBlockWithPath(192,160);
		blocks[i++] = createBlockWithPath(256,160);
		blocks[i++] = createBlockWithPath(320,160);
		
	}
	
	private Block createRockWithPath(int x, int y) {
		Block block = BlockFactory.createRockBlock(x, y);
		paths[0].addBlock(block);
		return block;
	}
	
	private Block createBlockWithPath(int x, int y) {
		Block block = new RectBlock(x, y, BlockImage.YELLOW);
		paths[1].addBlock(block);
		return block;
	}

	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
	@Override
	public Path[] getPaths() {
		return paths;
	}

	@Override
	public String getName() {
		return "Yellow";
	}

}
