package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level13 extends AbstractLevel {
	
	private Block[] blocks;
	
	public Level13() {
		int i = 0;
		blocks = new Block[74];
		
		for (int j=0;j<13;j++) {
			blocks[i++] = BlockFactory.createRockBlock(5*32,j*20);
			blocks[i++] = BlockFactory.createRockBlock(6*32,j*20);
		}

		blocks[i++] = new RectBlock(3*32,0*20,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(4*32,1*20,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(7*32,1*20,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(8*32,0*20,BlockImage.YELLOW);
		
		blocks[i++] = new RectBlock(0*32,12*20,BlockImage.WHITE,2);
		blocks[i++] = new RectBlock(1*32,13*20,BlockImage.WHITE,2);
		blocks[i++] = new RectBlock(10*32,13*20,BlockImage.WHITE,2);
		blocks[i++] = new RectBlock(11*32,12*20,BlockImage.WHITE,2);
		
		for (int j=0;j<5;j++) {
			blocks[i++] = new RectBlock(j*32,j*20,BlockImage.ORANGE);
			blocks[i++] = new RectBlock((j+7)*32,(4-j)*20,BlockImage.ORANGE);
			blocks[i++] = new RectBlock(j*32,(j+3)*20,BlockImage.RED);
			blocks[i++] = new RectBlock((j+7)*32,(7-j)*20,BlockImage.RED);
			blocks[i++] = new RectBlock(j*32,(j+6)*20,BlockImage.PINK);
			blocks[i++] = new RectBlock((j+7)*32,(10-j)*20,BlockImage.PINK);
			blocks[i++] = new RectBlock(j*32,(j+9)*20,BlockImage.BLUE);
			blocks[i++] = new RectBlock((j+7)*32,(13-j)*20,BlockImage.BLUE);
		}
	}
	
	@Override
	public String getName() {
		return "Sunray";
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}

}
