package ch.lanter.vajanoid.level;

import java.util.Random;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.CirclePath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level14 extends AbstractLevel {

	private Block[] blocks;
	private CirclePath[] paths;
	
	public Level14() {
		int i = 0;
		blocks = new Block[66];

		BlockImage[] images = new BlockImage[] {
				BlockImage.YELLOW,
				BlockImage.ORANGE,
				BlockImage.RED,
				BlockImage.PINK,
				BlockImage.PURPLE,
				BlockImage.BLUE,
				BlockImage.DARK_BLUE,
				BlockImage.GREEN,
				BlockImage.DARK_GREEN,
				BlockImage.WHITE,
				BlockImage.BLACK
		};
		int[] hps = new int[] {1,1,1,1,1,1,1,1,1,2,3};
		paths = new CirclePath[images.length];
		
		for (int k=0;k<paths.length;k++) {
			paths[k] = creatCirclePath();
			for (int j=0;j<6;j++) {
				Block block = new RectBlock(0,0,images[k%images.length],hps[k%images.length]);
				paths[k].addBlock(block);
				blocks[i++] = block;
			}
		}
	}
	
	private CirclePath creatCirclePath() {
		Random rand = new Random();
		int cx = rand.nextInt(384-40-32)+20+16;
		int cy = rand.nextInt(260-40-20)+20+10;
		float v = rand.nextFloat()*3+1f;
		int n = Math.min(
				Math.min(384-cx-16,260-cy-10),
				Math.min(cx-16,cy-10))-20+1;
		int rad = rand.nextInt(n)+20;
		return new CirclePath(cx,cy,rad,v);
	}
	
	@Override
	public void start() {
		for (CirclePath cp:paths) {
			cp.arrange();
		}
		super.start();
	}

	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
	@Override
	public Path[] getPaths() {
		return paths;
	}

	@Override
	public String getName() {
		return "Carnival";
	}

}
