package ch.lanter.vajanoid.level;

import java.util.Random;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.HorizontalPath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level16 extends AbstractLevel {

	private Block[] blocks;
	private Path[] paths;
	
	public Level16() {
		int i = 0;
		blocks = new Block[80];
		paths = new Path[10];
		for (int j=0;j<10;j++) {
			paths[j] = new HorizontalPath((j+5)*50f);
		}
		
		for (int j=0;j<10;j++) {
			for (int k=0;k<8;k++) {
				Block block = new RectBlock(k*48,j*20+20,getRand());
				paths[j].addBlock(block);
				blocks[i++] = block;
			}
		}
	}
	
	private BlockImage getRand() {
		BlockImage[] imgs = new BlockImage[] {
				BlockImage.YELLOW, BlockImage.ORANGE, BlockImage.RED,
				BlockImage.PINK, BlockImage.PURPLE, BlockImage.BLUE,
				BlockImage.DARK_BLUE, BlockImage.GREEN, BlockImage.DARK_GREEN				
		};
		return imgs[new Random().nextInt(imgs.length)];
	}

	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
	@Override
	public Path[] getPaths() {
		return paths;
	}

	@Override
	public String getName() {
		return "Highway";
	}

}
