package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.ItemType;
import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level17 extends AbstractLevel {

	private Block[] blocks;
	
	public Level17() {
		int i = 0;
		blocks = new Block[112];

		blocks[i++] = BlockFactory.createRockBlockItemer(32,0,BlockImage.RED,ItemType.RED);
		blocks[i++] = BlockFactory.createRockBlockItemer(320,0,BlockImage.BLUE,ItemType.BLUE);
		for (int j=0;j<8;j++) {
			blocks[i++] = new RectBlock(64+j*32,0,BlockImage.BLACK,3);
		}
		for (int k=0;k<10;k++) {
			for (int j=0;j<10;j++) {
				blocks[i++] = new RectBlock(32+j*32,20+k*20,BlockImage.BLACK,3);
			}
		}
		blocks[i++] = new RectBlock(0,200,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(352,200,BlockImage.BLACK,3);
	}
		
	@Override
	public Block[] getBlocks() {
		return blocks;
	}

	@Override
	public String getName() {
		return "Black Hole";
	}

}
