package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.Model;
import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.FleePath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level18 extends AbstractLevel {

	private Block[] blocks;
	private Path path;
	
	public Level18(Model model) {
		int i = 0;
		blocks = new Block[78];
		path = new FleePath(model,6f);

		for (int j=0;j<12;j++)
			blocks[i++] = createBlock(j*32,0+Math.abs(j*20-110),BlockImage.PINK);
		for (int j=0;j<12;j++)
			blocks[i++] = createBlock(j*32,20+Math.abs(j*20-110),BlockImage.DARK_BLUE);
		for (int j=0;j<12;j++)
			blocks[i++] = createBlock(j*32,40+Math.abs(j*20-110),BlockImage.RED);
		for (int j=0;j<12;j++)
			blocks[i++] = createBlock(j*32,100+Math.abs(j*20-110),BlockImage.ORANGE);
		for (int j=0;j<12;j++)
			blocks[i++] = createBlock(j*32,120+Math.abs(j*20-110),BlockImage.YELLOW);
		for (int j=0;j<12;j++)
			blocks[i++] = createBlock(j*32,140+Math.abs(j*20-110),BlockImage.GREEN);

		path.addBlock(blocks[i++] = BlockFactory.createRockBlock(3*32,10+5*20));
		path.addBlock(blocks[i++] = BlockFactory.createRockBlock(4*32,10+4*20));
		path.addBlock(blocks[i++] = BlockFactory.createRockBlock(4*32,10+5*20));
		path.addBlock(blocks[i++] = BlockFactory.createRockBlock(7*32,10+5*20));
		path.addBlock(blocks[i++] = BlockFactory.createRockBlock(7*32,10+4*20));
		path.addBlock(blocks[i++] = BlockFactory.createRockBlock(8*32,10+5*20));
	}
	
	private Block createBlock(int x, int y, BlockImage image) {
		Block block = new RectBlock(x, y, image);
		path.addBlock(block);
		return block;
	}
	
	@Override
	public Path[] getPaths() {
		return new Path[] {path};
	}

	@Override
	public Block[] getBlocks() {
		return blocks;
	}

	@Override
	public String getName() {
		return "Repulsion";
	}

}
