package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level21 extends AbstractLevel {

	private Block[] blocks;
	
	public Level21() {
		int i = 0;
		blocks = new Block[48];
		
		for (int j=0;j<6;j++) {
			blocks[i++] = new RectBlock(2*j*32,3*20,BlockImage.BLACK,3);
			blocks[i++] = new RectBlock((2*j+1)*32,5*20,BlockImage.BLACK,3);
		}
		
		for (int j=0;j<6;j++) {
			blocks[i++] = BlockFactory.createRockBlock(2*j*32,7*20);
			blocks[i++] = BlockFactory.createRockBlock((2*j+1)*32,9*20);
		}
		
		blocks[i++] = new RectBlock(0*32,6*20,BlockImage.RED);
		blocks[i++] = new RectBlock(1*32,8*20,BlockImage.RED);

		blocks[i++] = new RectBlock(0*32,2*20,BlockImage.PINK);
		blocks[i++] = new RectBlock(1*32,4*20,BlockImage.PINK);
		blocks[i++] = new RectBlock(2*32,6*20,BlockImage.PINK);
		blocks[i++] = new RectBlock(3*32,8*20,BlockImage.PINK);

		blocks[i++] = new RectBlock(2*32,2*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(3*32,4*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(4*32,6*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(5*32,8*20,BlockImage.PURPLE);

		blocks[i++] = new RectBlock(4*32,2*20,BlockImage.DARK_BLUE);
		blocks[i++] = new RectBlock(5*32,4*20,BlockImage.DARK_BLUE);
		blocks[i++] = new RectBlock(6*32,6*20,BlockImage.DARK_BLUE);
		blocks[i++] = new RectBlock(7*32,8*20,BlockImage.DARK_BLUE);

		blocks[i++] = new RectBlock(6*32,2*20,BlockImage.BLUE);
		blocks[i++] = new RectBlock(7*32,4*20,BlockImage.BLUE);
		blocks[i++] = new RectBlock(8*32,6*20,BlockImage.BLUE);
		blocks[i++] = new RectBlock(9*32,8*20,BlockImage.BLUE);

		blocks[i++] = new RectBlock(8*32,2*20,BlockImage.GREEN);
		blocks[i++] = new RectBlock(9*32,4*20,BlockImage.GREEN);
		blocks[i++] = new RectBlock(10*32,6*20,BlockImage.GREEN);
		blocks[i++] = new RectBlock(11*32,8*20,BlockImage.GREEN);

		blocks[i++] = new RectBlock(10*32,2*20,BlockImage.DARK_GREEN);
		blocks[i++] = new RectBlock(11*32,4*20,BlockImage.DARK_GREEN);
	}
	
	@Override
	public String getName() {
		return "Tile";
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
}
