package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.ItemType;
import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.CirclePath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level22 extends AbstractLevel {

	private Block[] blocks;
	private CirclePath path;
	
	public Level22() {
		int i = 0;
		path = new CirclePath(192f,140f,120f,2f);
		blocks = new Block[31];
		
		for (int j=0;j<24;j++) {
			blocks[i++] = createCircleBlock();
		}
		
		blocks[i++] = new RectBlock(160,110,BlockImage.PINK);
		blocks[i++] = new RectBlock(192,110,BlockImage.PINK);
		blocks[i++] = new RectBlock(144,130,BlockImage.PINK);
		blocks[i++] = new RectBlock(176,130,BlockImage.WHITE,2); // Purple items explosion?
		blocks[i++] = new RectBlock(208,130,BlockImage.PINK);
		blocks[i++] = new RectBlock(192,150,BlockImage.PINK);
		blocks[i++] = new RectBlock(160,150,BlockImage.PINK);
		
		path.arrange();
	}
	
	private Block createCircleBlock() {
		Block ret = BlockFactory.createBlockItemer(0, 0, BlockImage.PURPLE, ItemType.PURPLE);
		path.addBlock(ret);
		return ret;
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}

	@Override
	public Path[] getPaths() {
		return new Path[] {path};
	}
	
	@Override
	public String getName() {
		return "Circle";
	}
	
}
