package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.ItemType;
import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level23 extends AbstractLevel {

	private Block[] blocks;
	
	public Level23() {
		int i = 0;
		blocks = new Block[76];

		for (int j=3;j<=7;j++)
			blocks[i++] = new RectBlock(2*32,j*20,BlockImage.BLUE);
		
		for (int j=2;j<=8;j++)
			blocks[i++] = new RectBlock(3*32,j*20,BlockImage.BLUE);
		
		for (int j=1;j<=9;j++)
			blocks[i++] = new RectBlock(4*32,j*20,BlockImage.BLUE);
		
		blocks[i++] = new RectBlock(5*32,1*20,BlockImage.BLUE);
		for (int j=4;j<=9;j++)
			blocks[i++] = new RectBlock(5*32,j*20,BlockImage.BLUE);
		
		blocks[i++] = new RectBlock(6*32,1*20,BlockImage.BLUE);
		for (int j=4;j<=9;j++)
			blocks[i++] = new RectBlock(6*32,j*20,BlockImage.BLUE);

		for (int j=1;j<=4;j++)
			blocks[i++] = new RectBlock(7*32,j*20,BlockImage.BLUE);
		for (int j=6;j<=9;j++)
			blocks[i++] = new RectBlock(7*32,j*20,BlockImage.BLUE);

		for (int j=1;j<=3;j++)
			blocks[i++] = new RectBlock(8*32,j*20,BlockImage.BLUE);
		for (int j=7;j<=9;j++)
			blocks[i++] = new RectBlock(8*32,j*20,BlockImage.BLUE);

		blocks[i++] = BlockFactory.createBlockItemer(5*32,2*20,BlockImage.DARK_BLUE,ItemType.BLUE,1);
		blocks[i++] = BlockFactory.createBlockItemer(5*32,3*20,BlockImage.DARK_BLUE,ItemType.BLUE,1);
		blocks[i++] = BlockFactory.createBlockItemer(6*32,2*20,BlockImage.DARK_BLUE,ItemType.BLUE,1);
		blocks[i++] = BlockFactory.createBlockItemer(6*32,3*20,BlockImage.DARK_BLUE,ItemType.BLUE,1);
		
		blocks[i++] = BlockFactory.createRockBlock(1*32,3*20);
		blocks[i++] = BlockFactory.createRockBlock(1*32,4*20);
		blocks[i++] = BlockFactory.createRockBlock(1*32,5*20);
		blocks[i++] = BlockFactory.createRockBlock(1*32,6*20);
		blocks[i++] = BlockFactory.createRockBlock(1*32,7*20);
		blocks[i++] = BlockFactory.createRockBlock(2*32,2*20);
		blocks[i++] = BlockFactory.createRockBlock(2*32,8*20);
		blocks[i++] = BlockFactory.createRockBlock(3*32,1*20);
		blocks[i++] = BlockFactory.createRockBlock(3*32,9*20);
		blocks[i++] = BlockFactory.createRockBlock(4*32,0*20);
		blocks[i++] = BlockFactory.createRockBlock(4*32,10*20);
		blocks[i++] = BlockFactory.createRockBlock(5*32,0*20);
		blocks[i++] = BlockFactory.createRockBlock(5*32,10*20);
		blocks[i++] = BlockFactory.createRockBlock(6*32,0*20);
		blocks[i++] = BlockFactory.createRockBlock(6*32,10*20);
		blocks[i++] = BlockFactory.createRockBlock(7*32,0*20);
		blocks[i++] = BlockFactory.createRockBlock(7*32,10*20);
		blocks[i++] = BlockFactory.createRockBlock(8*32,0*20);
		blocks[i++] = BlockFactory.createRockBlock(8*32,10*20);
		blocks[i++] = BlockFactory.createRockBlock(9*32,1*20);
		blocks[i++] = BlockFactory.createRockBlock(9*32,2*20);
		blocks[i++] = BlockFactory.createRockBlock(9*32,8*20);
		blocks[i++] = BlockFactory.createRockBlock(9*32,9*20);
	}
	
	@Override
	public String getName() {
		return "Packman";
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
}
