package ch.lanter.vajanoid.level;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level25 extends AbstractLevel {

	private Block[] blocks;
	
	public Level25() {
		int i = 0;
		blocks = new Block[60];

		blocks[i++] = new RectBlock(1*32,5*20,BlockImage.DARK_GREEN);
		blocks[i++] = new RectBlock(2*32,5*20,BlockImage.GREEN);
		blocks[i++] = new RectBlock(3*32,5*20,BlockImage.DARK_BLUE);
		blocks[i++] = new RectBlock(4*32,5*20,BlockImage.BLUE);
		blocks[i++] = new RectBlock(5*32,5*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(6*32,5*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(7*32,5*20,BlockImage.BLUE);
		blocks[i++] = new RectBlock(8*32,5*20,BlockImage.DARK_BLUE);
		blocks[i++] = new RectBlock(9*32,5*20,BlockImage.GREEN);
		blocks[i++] = new RectBlock(10*32,5*20,BlockImage.DARK_GREEN);

		for (int j=1;j<11;j++)
			blocks[i++] = BlockFactory.createRockBlock(j*32,6*20);

		blocks[i++] = new RectBlock(1*32,9*20,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(2*32,9*20,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(3*32,9*20,BlockImage.RED);
		blocks[i++] = new RectBlock(4*32,9*20,BlockImage.PINK);
		blocks[i++] = new RectBlock(5*32,9*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(6*32,9*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(7*32,9*20,BlockImage.PINK);
		blocks[i++] = new RectBlock(8*32,9*20,BlockImage.RED);
		blocks[i++] = new RectBlock(9*32,9*20,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(10*32,9*20,BlockImage.YELLOW);

		for (int j=1;j<11;j++)
			blocks[i++] = BlockFactory.createRockBlock(j*32,10*20);

		blocks[i++] = new RectBlock(1*32,1*20,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(2*32,1*20,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(3*32,1*20,BlockImage.RED);
		blocks[i++] = new RectBlock(4*32,1*20,BlockImage.PINK);
		blocks[i++] = new RectBlock(5*32,1*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(6*32,1*20,BlockImage.PURPLE);
		blocks[i++] = new RectBlock(7*32,1*20,BlockImage.PINK);
		blocks[i++] = new RectBlock(8*32,1*20,BlockImage.RED);
		blocks[i++] = new RectBlock(9*32,1*20,BlockImage.ORANGE);
		blocks[i++] = new RectBlock(10*32,1*20,BlockImage.YELLOW);
		
		for (int j=1;j<11;j++)
			blocks[i++] = BlockFactory.createRockBlock(j*32,2*20);
		
	}
	
	@Override
	public String getName() {
		return "Despair";
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
}
