package ch.lanter.vajanoid.level;

import java.awt.Point;

import ch.lanter.vajanoid.ItemType;
import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.Path;
import ch.lanter.vajanoid.block.RectBlock;
import ch.lanter.vajanoid.path.PolygonalPath;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level26 extends AbstractLevel {

	private Block[] blocks;
	private PolygonalPath path;
	
	public Level26() {
		int i = 0;
		blocks = new Block[105];
		path = new PolygonalPath(200f);
		path.addVertice(new Point(96,0));
		path.addVertice(new Point(256,0));
		path.addVertice(new Point(256,180));
		path.addVertice(new Point(96,180));

		for (int j=0;j<3;j++) {
			blocks[i++] = BlockFactory.createRockBlock(j*32,0);
			blocks[i++] = BlockFactory.createRockBlock(j*32,20);
			blocks[i++] = BlockFactory.createRockBlock(j*32+288,0);
			blocks[i++] = BlockFactory.createRockBlock(j*32+288,20);
		}
		
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,0) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(128,0) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(160,0) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(192,0) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(224,0) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,0) );

		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,20) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,40) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,60) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,80) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,100) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,120) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,140) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(256,160) );
		
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(224,180) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(192,180) );
		path.addBlock( blocks[i++] = new RectBlock(160,180,BlockImage.BLACK,3) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(128,180) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,180) );

		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,160) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,140) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,120) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,100) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,80) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,60) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,40) );
		path.addBlock( blocks[i++] = BlockFactory.createRockBlock(96,20) );

		blocks[i++] = BlockFactory.createRockBlock(288,140);
		blocks[i++] = BlockFactory.createRockBlock(352,140);
		blocks[i++] = BlockFactory.createRockBlock(0,140);
		blocks[i++] = BlockFactory.createRockBlock(64,140);

		for (int j=0;j<8;j++)
			for (int k=0;k<4;k++)
				blocks[i++] = new RectBlock(128+k*32,20+j*20,BlockImage.BLACK,3);
		
		blocks[i++] = new RectBlock(0 ,40,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(32,40,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(64,40,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(0 ,60,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(32,60,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(64,60,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(0,80,BlockImage.YELLOW);
		blocks[i++] = BlockFactory.createRockBlockItemer(32,80,BlockImage.ORANGE,ItemType.ORANGE);
		blocks[i++] = new RectBlock(64,80,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(0 ,100,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(32,100,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(64,100,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(0 ,120,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(32,120,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(64,120,BlockImage.YELLOW);
		
		blocks[i++] = new RectBlock(288,40,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(320,40,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(352,40,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(288,60,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(320,60,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(352,60,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(288,80,BlockImage.YELLOW);
		blocks[i++] = BlockFactory.createRockBlockItemer(320,80,BlockImage.ORANGE,ItemType.ORANGE);
		blocks[i++] = new RectBlock(352,80,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(288,100,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(320,100,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(352,100,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(288,120,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(320,120,BlockImage.YELLOW);
		blocks[i++] = new RectBlock(352,120,BlockImage.YELLOW);
	}
	
	@Override
	public void start() {
		path.arrange();
		super.start();
	}

	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
	@Override
	public Path[] getPaths() {
		return new Path[] {path};
	}

	@Override
	public String getName() {
		return "Goldorpitch";
	}

}
