package ch.lanter.vajanoid.level;

import java.util.Observable;

import ch.lanter.vajanoid.BallEvent;
import ch.lanter.vajanoid.Model;
import ch.lanter.vajanoid.BallEvent.TYPE;
import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.BlockFactory;
import ch.lanter.vajanoid.block.BlockImage;
import ch.lanter.vajanoid.block.RectBlock;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class Level27 extends AbstractLevel {

	private Block[] blocks;
	
	private Block[] blocks1;
	private Block[] blocks2;
	
	private boolean one; // true, if blocks1 is visible
	private boolean isStarted;
	
	public Level27(Model model) {
		this.one = true;
		this.isStarted = false;
		
		int i = 0;
		blocks = new Block[48];
		
		blocks1 = new Block[18];
		blocks2 = new Block[18];

		int j = 0;
		blocks1[j++] = BlockFactory.createRockBlock(1*32,11*20);
		blocks1[j++] = BlockFactory.createRockBlock(1*32, 9*20);
		blocks1[j++] = BlockFactory.createRockBlock(1*32, 7*20);
		blocks1[j++] = BlockFactory.createRockBlock(1*32, 5*20);
		blocks1[j++] = BlockFactory.createRockBlock(1*32, 3*20);
		blocks1[j++] = BlockFactory.createRockBlock(3*32, 3*20);
		blocks1[j++] = BlockFactory.createRockBlock(5*32, 3*20);
		blocks1[j++] = BlockFactory.createRockBlock(7*32, 3*20);
		blocks1[j++] = BlockFactory.createRockBlock(9*32, 3*20);
		blocks1[j++] = BlockFactory.createRockBlock(10*32,4*20);
		blocks1[j++] = BlockFactory.createRockBlock(10*32,6*20);
		blocks1[j++] = BlockFactory.createRockBlock(10*32,8*20);
		blocks1[j++] = BlockFactory.createRockBlock(10*32,10*20);
		blocks1[j++] = BlockFactory.createRockBlock(10*32,12*20);
		blocks1[j++] = BlockFactory.createRockBlock(2*32,12*20);
		blocks1[j++] = BlockFactory.createRockBlock(4*32,12*20);
		blocks1[j++] = BlockFactory.createRockBlock(6*32,12*20);
		blocks1[j++] = BlockFactory.createRockBlock(8*32,12*20);
		i += j;

		int k = 0;
		blocks2[k++] = BlockFactory.createRockBlock(1*32,12*20);
		blocks2[k++] = BlockFactory.createRockBlock(1*32,10*20);
		blocks2[k++] = BlockFactory.createRockBlock(1*32, 8*20);
		blocks2[k++] = BlockFactory.createRockBlock(1*32, 6*20);
		blocks2[k++] = BlockFactory.createRockBlock(1*32, 4*20);
		blocks2[k++] = BlockFactory.createRockBlock(2*32, 3*20);
		blocks2[k++] = BlockFactory.createRockBlock(4*32, 3*20);
		blocks2[k++] = BlockFactory.createRockBlock(6*32, 3*20);
		blocks2[k++] = BlockFactory.createRockBlock(8*32, 3*20);
		blocks2[k++] = BlockFactory.createRockBlock(10*32,3*20);
		blocks2[k++] = BlockFactory.createRockBlock(10*32,5*20);
		blocks2[k++] = BlockFactory.createRockBlock(10*32,7*20);
		blocks2[k++] = BlockFactory.createRockBlock(10*32,9*20);
		blocks2[k++] = BlockFactory.createRockBlock(10*32,11*20);
		blocks2[k++] = BlockFactory.createRockBlock(3*32,12*20);
		blocks2[k++] = BlockFactory.createRockBlock(5*32,12*20);
		blocks2[k++] = BlockFactory.createRockBlock(7*32,12*20);
		blocks2[k++] = BlockFactory.createRockBlock(9*32,12*20);
		i += k;

		System.arraycopy(blocks1, 0, blocks, 0, blocks1.length);
		System.arraycopy(blocks2, 0, blocks, blocks1.length, blocks2.length);

		blocks[i++] = new RectBlock(5*32,7*20,BlockImage.WHITE,2);
		blocks[i++] = new RectBlock(5*32,8*20,BlockImage.WHITE,2);
		blocks[i++] = new RectBlock(6*32,7*20,BlockImage.WHITE,2);
		blocks[i++] = new RectBlock(6*32,8*20,BlockImage.WHITE,2);

		blocks[i++] = new RectBlock(4*32,7*20,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(4*32,8*20,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(5*32,6*20,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(6*32,6*20,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(7*32,8*20,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(7*32,7*20,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(5*32,9*20,BlockImage.BLACK,3);
		blocks[i++] = new RectBlock(6*32,9*20,BlockImage.BLACK,3);
	}
	
	@Override
	public void update(Observable o, Object arg) {
		if (!isStarted) return;
		BallEvent event = (BallEvent) arg;
		if (event.getType()==TYPE.BALL_PADDED) {
			if (one) {
				for (Block b:blocks1) b.setActive(true);
				for (Block b:blocks2) b.setActive(false);
			} else {
				for (Block b:blocks1) b.setActive(false);
				for (Block b:blocks2) b.setActive(true);
			}
			one = !one;
		}
	}
	
	@Override
	public void start() {
		super.start();
		isStarted = true;
	}
	
	@Override
	public Block[] getBlocks() {
		return blocks;
	}
	
	@Override
	public String getName() {
		return "Quicky";
	}
}
