package ch.lanter.vajanoid.path;

import java.util.ArrayList;
import java.util.Iterator;

import ch.lanter.vajanoid.block.Block;
import ch.lanter.vajanoid.block.Path;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public abstract class AbstractPath implements Path {

	private ArrayList<Block> blocks; 
	
	public AbstractPath() {
		blocks = new ArrayList<Block>();
	}
	
	public void addBlock(Block block) {
		blocks.add(block);
	}
	
	public Iterator<Block> getBlockIterator() {
		return blocks.iterator();
	}
	
/*	
 	public Block[] getBlocks() {
		Block[] ret = new Block[blocks.size()];
		blocks.toArray(ret);
		return ret;
	}
*/
	
	public int getCount() {
		return blocks.size();
	}
	
	public abstract void step(long dt);
}
