package ch.lanter.vajanoid.path;

import java.util.Iterator;

import ch.lanter.vajanoid.block.Block;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class HorizontalPath extends AbstractPath {

	private float x,vx;
	
	public HorizontalPath(float vx) {
		this.x = 0;
		this.vx = vx;
	}
	
	public void step(long dt) {
		float fdx = dt*vx/1000;
		int dx = Math.round(x+fdx)-Math.round(x);
		Iterator<Block> iterator = getBlockIterator();
		while (iterator.hasNext()) {
			Block block = iterator.next();
			int x = (block.getBlockX()+dx)%block.getXMax();
			block.setBlockX(x);
		}
		x = x+fdx;
	}
}
