package ch.lanter.vajanoid.path;

import java.util.Iterator;

import ch.lanter.vajanoid.block.Block;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class VerticalPath extends AbstractPath {

	private float y, vy;
	
	public VerticalPath(float vy) {
		this.y = 0;
		this.vy = vy;
	}

	@Override
	public void step(long dt) {
		float fdy = dt*vy/1000;
		int dx = Math.round(y+fdy)-Math.round(y);
		Iterator<Block> iterator = getBlockIterator();
		while (iterator.hasNext()) {
			Block block = iterator.next();
			int y = (block.getBlockY()+dx)%block.getYMax();
			block.setBlockY(y);
		}
		y = y+fdy;
	}

}
