package ch.lanter.vajanoid.path;

import java.util.Iterator;

import ch.lanter.vajanoid.block.Block;

/**
 * @author Martin Lanter, Lantersoft 2010
 */
public class VerticalSwayPath extends AbstractPath {

	private int deltay;
	private float y, vy;

	public VerticalSwayPath(int deltay, float vy) {
		this(deltay,vy,0);
	}
	
	public VerticalSwayPath(int deltay, float vy, float init) {
		this.deltay = deltay;
		this.vy = vy;
		this.y = init;
	}

	@Override
	public void step(long dt) {
		float fdy = dt*vy/1000;
		int dy = 0;
		if ((y+fdy)%(2*deltay)<=deltay) {
			dy = (Math.round(y+fdy)-Math.round(y))%deltay;
		} else {
			dy = -((Math.round(y+fdy)-Math.round(y))%deltay);
		}

		Iterator<Block> iterator = getBlockIterator();
		while (iterator.hasNext()) {
			Block block = iterator.next();
			int y = (block.getBlockY()+dy+block.getYMax())%block.getYMax();
			block.setBlockY(y);
		}
		
		y = y+fdy;
	}

}
